// Generated by purs version 0.14.3
"use strict";
var Data_DateTime_Instant = require("../Data.DateTime.Instant/index.js");
var Data_EuclideanRing = require("../Data.EuclideanRing/index.js");
var Data_Function = require("../Data.Function/index.js");
var Data_Functor = require("../Data.Functor/index.js");
var Data_Int = require("../Data.Int/index.js");
var Data_Maybe = require("../Data.Maybe/index.js");
var Data_Nullable = require("../Data.Nullable/index.js");
var Data_Show = require("../Data.Show/index.js");
var Effect = require("../Effect/index.js");
var Node_Buffer = require("../Node.Buffer/index.js");
var Node_Buffer_Class = require("../Node.Buffer.Class/index.js");
var Node_Encoding = require("../Node.Encoding/index.js");
var Node_FS = require("../Node.FS/index.js");
var Node_FS_Internal = require("../Node.FS.Internal/index.js");
var Node_FS_Perms = require("../Node.FS.Perms/index.js");
var Node_FS_Stats = require("../Node.FS.Stats/index.js");
var fs = Node_FS_Internal.unsafeRequireFS;
var link = function (src) {
    return function (dst) {
        return Node_FS_Internal.mkEffect(function (v) {
            return fs.linkSync(src, dst);
        });
    };
};
var mkdir$prime = function (file) {
    return function (perms) {
        return Node_FS_Internal.mkEffect(function (v) {
            return fs.mkdirSync(file, Node_FS_Perms.permsToString(perms));
        });
    };
};
var mkdir = Data_Function.flip(mkdir$prime)(Node_FS_Perms.mkPerms(Node_FS_Perms.all)(Node_FS_Perms.all)(Node_FS_Perms.all));
var readFile = function (file) {
    return Node_FS_Internal.mkEffect(function (v) {
        return fs.readFileSync(file, {});
    });
};
var readTextFile = function (encoding) {
    return function (file) {
        return Node_FS_Internal.mkEffect(function (v) {
            return fs.readFileSync(file, {
                encoding: Data_Show.show(Node_Encoding.showEncoding)(encoding)
            });
        });
    };
};
var readdir = function (file) {
    return Node_FS_Internal.mkEffect(function (v) {
        return fs.readdirSync(file);
    });
};
var readlink = function (path) {
    return Node_FS_Internal.mkEffect(function (v) {
        return fs.readlinkSync(path);
    });
};
var realpath = function (path) {
    return Node_FS_Internal.mkEffect(function (v) {
        return fs.realpathSync(path, {});
    });
};
var realpath$prime = function (path) {
    return function (cache) {
        return Node_FS_Internal.mkEffect(function (v) {
            return fs.realpathSync(path, cache);
        });
    };
};
var rename = function (oldFile) {
    return function (newFile) {
        return Node_FS_Internal.mkEffect(function (v) {
            return fs.renameSync(oldFile, newFile);
        });
    };
};
var rmdir = function (file) {
    return Node_FS_Internal.mkEffect(function (v) {
        return fs.rmdirSync(file);
    });
};
var stat = function (file) {
    return Data_Functor.map(Effect.functorEffect)(Node_FS_Stats.Stats.create)(Node_FS_Internal.mkEffect(function (v) {
        return fs.statSync(file);
    }));
};
var symlink = function (src) {
    return function (dst) {
        return function (ty) {
            return Node_FS_Internal.mkEffect(function (v) {
                return fs.symlinkSync(src, dst, Node_FS.symlinkTypeToNode(ty));
            });
        };
    };
};
var truncate = function (file) {
    return function (len) {
        return Node_FS_Internal.mkEffect(function (v) {
            return fs.truncateSync(file, len);
        });
    };
};
var unlink = function (file) {
    return Node_FS_Internal.mkEffect(function (v) {
        return fs.unlinkSync(file);
    });
};
var utimes = function (file) {
    return function (atime) {
        return function (mtime) {
            var toEpochMilliseconds = function ($29) {
                return Data_DateTime_Instant.unInstant(Data_DateTime_Instant.fromDateTime($29));
            };
            var ms = function (v) {
                return Data_Int.round(v);
            };
            var fromDate = function (date) {
                return Data_EuclideanRing.div(Data_EuclideanRing.euclideanRingInt)(ms(toEpochMilliseconds(date)))(1000);
            };
            return Node_FS_Internal.mkEffect(function (v) {
                return fs.utimesSync(file, fromDate(atime), fromDate(mtime));
            });
        };
    };
};
var writeFile = function (file) {
    return function (buff) {
        return Node_FS_Internal.mkEffect(function (v) {
            return fs.writeFileSync(file, buff, {});
        });
    };
};
var writeTextFile = function (encoding) {
    return function (file) {
        return function (text) {
            return Node_FS_Internal.mkEffect(function (v) {
                return fs.writeFileSync(file, text, {
                    encoding: Data_Show.show(Node_Encoding.showEncoding)(encoding)
                });
            });
        };
    };
};
var fdWrite = function (fd) {
    return function (buff) {
        return function (off) {
            return function (len) {
                return function (pos) {
                    return Node_FS_Internal.mkEffect(function (v) {
                        return fs.writeSync(fd, buff, off, len, Data_Nullable.toNullable(pos));
                    });
                };
            };
        };
    };
};
var fdRead = function (fd) {
    return function (buff) {
        return function (off) {
            return function (len) {
                return function (pos) {
                    return Node_FS_Internal.mkEffect(function (v) {
                        return fs.readSync(fd, buff, off, len, Data_Nullable.toNullable(pos));
                    });
                };
            };
        };
    };
};
var fdOpen = function (file) {
    return function (flags) {
        return function (mode) {
            return Node_FS_Internal.mkEffect(function (v) {
                return fs.openSync(file, Node_FS.fileFlagsToNode(flags), Data_Nullable.toNullable(mode));
            });
        };
    };
};
var fdNext = function (fd) {
    return function (buff) {
        return function __do() {
            var sz = Node_Buffer_Class.size(Node_Buffer.mutableBufferEffect)(buff)();
            return fdRead(fd)(buff)(0)(sz)(Data_Maybe.Nothing.value)();
        };
    };
};
var fdFlush = function (fd) {
    return Node_FS_Internal.mkEffect(function (v) {
        return fs.fsyncSync(fd);
    });
};
var fdClose = function (fd) {
    return Node_FS_Internal.mkEffect(function (v) {
        return fs.closeSync(fd);
    });
};
var fdAppend = function (fd) {
    return function (buff) {
        return function __do() {
            var sz = Node_Buffer_Class.size(Node_Buffer.mutableBufferEffect)(buff)();
            return fdWrite(fd)(buff)(0)(sz)(Data_Maybe.Nothing.value)();
        };
    };
};
var exists = function (file) {
    return Node_FS_Internal.mkEffect(function (v) {
        return fs.existsSync(file);
    });
};
var chown = function (file) {
    return function (uid) {
        return function (gid) {
            return Node_FS_Internal.mkEffect(function (v) {
                return fs.chownSync(file, uid, gid);
            });
        };
    };
};
var chmod = function (file) {
    return function (perms) {
        return Node_FS_Internal.mkEffect(function (v) {
            return fs.chmodSync(file, Node_FS_Perms.permsToString(perms));
        });
    };
};
var appendTextFile = function (encoding) {
    return function (file) {
        return function (buff) {
            return Node_FS_Internal.mkEffect(function (v) {
                return fs.appendFileSync(file, buff, {
                    encoding: Data_Show.show(Node_Encoding.showEncoding)(encoding)
                });
            });
        };
    };
};
var appendFile = function (file) {
    return function (buff) {
        return Node_FS_Internal.mkEffect(function (v) {
            return fs.appendFileSync(file, buff, {});
        });
    };
};
module.exports = {
    rename: rename,
    truncate: truncate,
    chown: chown,
    chmod: chmod,
    stat: stat,
    link: link,
    symlink: symlink,
    readlink: readlink,
    realpath: realpath,
    "realpath'": realpath$prime,
    unlink: unlink,
    rmdir: rmdir,
    mkdir: mkdir,
    "mkdir'": mkdir$prime,
    readdir: readdir,
    utimes: utimes,
    readFile: readFile,
    readTextFile: readTextFile,
    writeFile: writeFile,
    writeTextFile: writeTextFile,
    appendFile: appendFile,
    appendTextFile: appendTextFile,
    exists: exists,
    fdOpen: fdOpen,
    fdRead: fdRead,
    fdNext: fdNext,
    fdWrite: fdWrite,
    fdAppend: fdAppend,
    fdFlush: fdFlush,
    fdClose: fdClose
};
